package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * Port IPv6 setting
 */
@ApiModel(description = "Port IPv6 setting")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class WanPortIpv6SettingOpenApiVo   {
  @JsonProperty("enable")
  private Boolean enable;

  @JsonProperty("protoType")
  private Integer protoType;

  @JsonProperty("ipv6Dynamic")
  private Ipv6DynamicOpenApiVo ipv6Dynamic;

  @JsonProperty("ipv6Pppoe")
  private Ipv6PppoeOpenApiVo ipv6Pppoe;

  @JsonProperty("ipv6Tunnel")
  private Ipv6TunnelOpenApiVo ipv6Tunnel;

  @JsonProperty("ipv6Static")
  private Ipv6StaticOpenApiVo ipv6Static;

  public WanPortIpv6SettingOpenApiVo enable(Boolean enable) {
    this.enable = enable;
    return this;
  }

  /**
   * Get enable
   * @return enable
  */
  @ApiModelProperty(required = true, value = "")
  @NotNull


  public Boolean getEnable() {
    return enable;
  }

  public void setEnable(Boolean enable) {
    this.enable = enable;
  }

  public WanPortIpv6SettingOpenApiVo protoType(Integer protoType) {
    this.protoType = protoType;
    return this;
  }

  /**
   * IPv4 connection type should be a value as follows: 0: static; 1: dynamic; 2: PPPoE; 3: 6to4Tunnel; 4: bridge.
   * @return protoType
  */
  @ApiModelProperty(value = "IPv4 connection type should be a value as follows: 0: static; 1: dynamic; 2: PPPoE; 3: 6to4Tunnel; 4: bridge.")


  public Integer getProtoType() {
    return protoType;
  }

  public void setProtoType(Integer protoType) {
    this.protoType = protoType;
  }

  public WanPortIpv6SettingOpenApiVo ipv6Dynamic(Ipv6DynamicOpenApiVo ipv6Dynamic) {
    this.ipv6Dynamic = ipv6Dynamic;
    return this;
  }

  /**
   * Get ipv6Dynamic
   * @return ipv6Dynamic
  */
  @ApiModelProperty(value = "")

  @Valid

  public Ipv6DynamicOpenApiVo getIpv6Dynamic() {
    return ipv6Dynamic;
  }

  public void setIpv6Dynamic(Ipv6DynamicOpenApiVo ipv6Dynamic) {
    this.ipv6Dynamic = ipv6Dynamic;
  }

  public WanPortIpv6SettingOpenApiVo ipv6Pppoe(Ipv6PppoeOpenApiVo ipv6Pppoe) {
    this.ipv6Pppoe = ipv6Pppoe;
    return this;
  }

  /**
   * Get ipv6Pppoe
   * @return ipv6Pppoe
  */
  @ApiModelProperty(value = "")

  @Valid

  public Ipv6PppoeOpenApiVo getIpv6Pppoe() {
    return ipv6Pppoe;
  }

  public void setIpv6Pppoe(Ipv6PppoeOpenApiVo ipv6Pppoe) {
    this.ipv6Pppoe = ipv6Pppoe;
  }

  public WanPortIpv6SettingOpenApiVo ipv6Tunnel(Ipv6TunnelOpenApiVo ipv6Tunnel) {
    this.ipv6Tunnel = ipv6Tunnel;
    return this;
  }

  /**
   * Get ipv6Tunnel
   * @return ipv6Tunnel
  */
  @ApiModelProperty(value = "")

  @Valid

  public Ipv6TunnelOpenApiVo getIpv6Tunnel() {
    return ipv6Tunnel;
  }

  public void setIpv6Tunnel(Ipv6TunnelOpenApiVo ipv6Tunnel) {
    this.ipv6Tunnel = ipv6Tunnel;
  }

  public WanPortIpv6SettingOpenApiVo ipv6Static(Ipv6StaticOpenApiVo ipv6Static) {
    this.ipv6Static = ipv6Static;
    return this;
  }

  /**
   * Get ipv6Static
   * @return ipv6Static
  */
  @ApiModelProperty(value = "")

  @Valid

  public Ipv6StaticOpenApiVo getIpv6Static() {
    return ipv6Static;
  }

  public void setIpv6Static(Ipv6StaticOpenApiVo ipv6Static) {
    this.ipv6Static = ipv6Static;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    WanPortIpv6SettingOpenApiVo wanPortIpv6SettingOpenApiVo = (WanPortIpv6SettingOpenApiVo) o;
    return Objects.equals(this.enable, wanPortIpv6SettingOpenApiVo.enable) &&
        Objects.equals(this.protoType, wanPortIpv6SettingOpenApiVo.protoType) &&
        Objects.equals(this.ipv6Dynamic, wanPortIpv6SettingOpenApiVo.ipv6Dynamic) &&
        Objects.equals(this.ipv6Pppoe, wanPortIpv6SettingOpenApiVo.ipv6Pppoe) &&
        Objects.equals(this.ipv6Tunnel, wanPortIpv6SettingOpenApiVo.ipv6Tunnel) &&
        Objects.equals(this.ipv6Static, wanPortIpv6SettingOpenApiVo.ipv6Static);
  }

  @Override
  public int hashCode() {
    return Objects.hash(enable, protoType, ipv6Dynamic, ipv6Pppoe, ipv6Tunnel, ipv6Static);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class WanPortIpv6SettingOpenApiVo {\n");
    
    sb.append("    enable: ").append(toIndentedString(enable)).append("\n");
    sb.append("    protoType: ").append(toIndentedString(protoType)).append("\n");
    sb.append("    ipv6Dynamic: ").append(toIndentedString(ipv6Dynamic)).append("\n");
    sb.append("    ipv6Pppoe: ").append(toIndentedString(ipv6Pppoe)).append("\n");
    sb.append("    ipv6Tunnel: ").append(toIndentedString(ipv6Tunnel)).append("\n");
    sb.append("    ipv6Static: ").append(toIndentedString(ipv6Static)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

